// -*-c++-*-

/*
 *Copyright:

 Copyright (C) Hidehisa AKIYAMA

 This code is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 3, or (at your option)
 any later version.

 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU Gener
 This code is distributed in the hope that it will be useful,al Public License
 along with this code; see the file COPYING.  If not, write to
 the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.

 *EndCopyright:
 */

/////////////////////////////////////////////////////////////////////

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include "bhv_basic_move_SideBack.h"

#include "strategy.h"

#include "bhv_basic_tackle.h"

#include <rcsc/action/basic_actions.h>
#include <rcsc/action/body_go_to_point.h>
#include <rcsc/action/body_intercept.h>
#include <rcsc/action/neck_turn_to_ball_or_scan.h>
#include <rcsc/action/neck_turn_to_low_conf_teammate.h>

#include <rcsc/player/player_agent.h>
#include <rcsc/player/debug_client.h>
#include <rcsc/player/intercept_table.h>

#include <rcsc/common/logger.h>
#include <rcsc/common/server_param.h>

#include "neck_offensive_intercept_neck.h"



#include <rcsc/action/body_pass.h> //1004追記
#include <rcsc/action/body_dribble.h>　//1004追記



using namespace rcsc;

/*-------------------------------------------------------------------*/
/*!

 */
bool
Bhv_BasicMove_SideBack::execute( PlayerAgent * agent )
{
    dlog.addText( Logger::TEAM,
                  __FILE__": Bhv_BasicMove_SideBack" );

    //-----------------------------------------------
    // tackle
    // if ( Bhv_BasicTackle( 0.8, 80.0 ).execute( agent ) )
 if ( Bhv_BasicTackle.execute( agent ) )
    {
        return true;
    }

    const WorldModel & wm = agent->world();
    /*--------------------------------------------------------*/
    // chase ball
    const int self_min = wm.interceptTable()->selfReachCycle();
    const int mate_min = wm.interceptTable()->teammateReachCycle();
    const int opp_min = wm.interceptTable()->opponentReachCycle();

    if ( ! wm.existKickableTeammate()
         && ( self_min <= 10     //3  //6(1012変更)
              || ( self_min <= mate_min
                   && self_min < opp_min + 5 )  //3 // +5(1012変更)
              )
         )
    {
        dlog.addText( Logger::TEAM,
                      __FILE__": intercept" );
        Body_Intercept().execute( agent );
        agent->setNeckAction( new Neck_OffensiveInterceptNeck() );

        return true;
    }

    const Vector2D target_point = Strategy::i().getPosition( wm.self().unum() );  //自分の今の位置を得る
    const double dash_power = Bhv_BasicMove_SideBack::getDashPower( agent );

      //Strategy::get_normal_dash_power( wm );    //走るスピードを得る

    double dist_thr = wm.ball().distFromSelf() * 0.5;      //自分とボールの距離を得る

    if ( dist_thr < 1.0 ) dist_thr = 1.0;    //距離が小数になったら１に切り上げ

    dlog.addText( Logger::TEAM,
                  __FILE__": Bhv_BasicMove_SideBack target=(%.1f %.1f) dist_thr=%.2f",     //値の表示
                  target_point.x, target_point.y,
                  dist_thr );

    agent->debugClient().addMessage( "BasicMove%.0f", dash_power );  //メッセージの出力
    agent->debugClient().setTarget( target_point );   //自分の背番号を返す
    agent->debugClient().addCircle( target_point, dist_thr );  //内外判定、直線との交点を求める   

    if ( ! Body_GoToPoint( target_point, dist_thr, dash_power
                           ).execute( agent ) )
    {
      Body_TurnToBall().execute( agent );  //回転動作を実行する
    }

    if ( wm.existKickableOpponent()
         && wm.ball().distFromSelf() < 18.0 )
    {
      agent->setNeckAction( new Neck_TurnToBall() );   //次のサイクルの予測ボール位置へ視界を向ける
    }
    else
    {
      agent->setNeckAction( new Neck_TurnToBallOrScan() );  //p76
    }

   

    
    ////////////////////////////////////////////////////1004追記

       //ボールを持っている時の判断（インターセプトサイクルから）

   

    if( opp_min >  self_min + 8.5)
    {

      //(opp_min >  self_min + 4.5 )

      const int dash_count = 2;
      const bool dodge_mode = true;   //trueなら敵を自動回避
      
      double dribble_dash_power = dash_power * 1.1;
      Body_Dribble(target_point, dist_thr ,dribble_dash_power,dodge_mode).execute( agent );
   



 if(opp_min >=  self_min + 3.0 )

    {

      double first_speed = 10;       //パススピード
      int receiver = 0    ;          //???
      Vector2D  target_point = Strategy::i().getPosition( wm.self().unum() );


      Body_Pass:: get_best_pass( agent->world(), &target_point, &first_speed, &receiver);    //1006追記 パスが可能か否か
      Body_Pass().execute( agent );                 //パスの実行 

    }

    }/*

    double ball_pos_x = wm.ball().pos().x;



    if(ball_pos_x <= 0.0)
{
                                                              
  double dash_power2= dash_power * 2.0;

  Body_GoToPoint(target_point ,dist_thr,dash_power2).execute(agent);

}

     
    */

    return true;
}


    ////////////////////////////////////////////////////////////////////1009追記
       //スタミナ管理
    

double Bhv_BasicMove_SideBack::getDashPower(const PlayerAgent * agent ) {
      // ローカル static 変数で回復モードを管理する

  static bool s_recover_mode = false;
  const WorldModel & wm = agent->world();

  if ( wm.self().stamina() < ServerParam::i().staminaMax() * 0.5 ) {
	s_recover_mode = true;
  } else if ( wm.self().stamina()
	      > ServerParam::i().staminaMax() * 0.7 ) {
    s_recover_mode = false;
  }
  double dash_power = ServerParam::i().maxPower();

  // 1 サイクルあたりのスタミナ回復量
   const double my_inc
    = wm.self().playerType().staminaIncMax() * wm.self().recovery();


    double ball_pos_x = wm.ball().pos().x;
    if ((ball_pos_x <= 0.0)||( wm.existKickableOpponent()) ) {
  

// if ( wm.getDefenseLineX() > wm.self().pos().x
     //  && wm.ball().pos().x < wm.getDefenseLineX() + 20.0 )

// ディフェンスラインよりも後方にいる場合
    
    dash_power = ServerParam::i().maxPower();
    } else if ( s_recover_mode ) {
    // 回復モードでは 1 サイクル 25 以上の回復量を確保する
    
    dash_power = std::max( 0.0, my_inc - 25.0 );
  } else if ( wm.existKickableTeammate()
	      && wm.ball().distFromSelf() < 20.0 ) {
    // 味方が近くでボールを持っていれば,移動速度を早める
    
    dash_power = std::min( my_inc * 1.1,
			   ServerParam::i().maxPower() );
  }/* else if ( wm.self().pos().x > wm.getOffsideLineX() ) {
    // オフサイド位置であれば全力で戻る
    
    dash_power = ServerParam::i().maxPower();
    }*/ else {
    // 通常時は回復量よりも大きいダッシュパワーで移動する
    
    dash_power = std::min( my_inc * 10.0,
			   ServerParam::i().maxPower() );
  }
  
  return dash_power;
  
}

